/*
sine_waves by PPs for nyd23
*/

	.zpvar	.word delta,value

sintab=$f0				;will overwrite the stack, but I don't need it
fnt = $4400				;we have this ($44) after rol of dma

	org $2000
	.proc main
;------------
	.local gen_sintab
	ldy #$3f
	ldx #$0
 	stx $d208
ly	adw value delta			;high byte of value+delta stored as sin value
	sta sintab+$c0,x
	sta sintab+$80,y
	eor #$7f
	sta sintab+$40,x
	sta sintab+$00,y
	lda delta
	adc #$3				;this value adds up to the proper amplitude
	sta delta
	bcc @+
	inc delta+1
@	inx
	dey
	bpl ly
	.endl
;------------
	.local gen_fnt
	ldx #15
lx	ldy #7
ly	lda #$ff
chg	sta fnt+8*15,y
	dey
	bpl ly
	lda ly+1
	sub #$11
	sta ly+1
;---					low byte is enough - 16 chars only
	lda chg+1
	sbc #8
	sta chg+1
;---
	dex
	bpl lx
	.endl
;------------
	mva #$22 559
	rol				;$44
	sta 623				;GTIA mode on
	sta 756				;set font
	mva #%10100011 $d201		;for noise
mainloop
	lda 20
@	cmp 20
	beq @-
	and #$f0
	sta 712
;------------
	.local waves
	mwa 88 delta
	ldy #23
l_y	ldx #39
l_x	sty value
	txa
	adc 20
	tay
	lda sintab,y
	adc value
	sta $d200			;make some noise
	and #$f				;color 0-$f
	ldy #0
	sta (delta),y
	inw delta
	ldy value
	dex
	bpl l_x
	dey
	bpl l_y
	.endl
;------------
	jmp mainloop
	.endp
;------------
	run main